
#ifndef ClickDlg_H
#define ClickDlg_H

#include <qvariant.h>
#include <qdialog.h>
#include <qcheckbox.h>
#include <qcombobox.h>
#include <qgroupbox.h>
#include <qlabel.h>
#include <qlineedit.h>
#include <qpushbutton.h>
#include <qspinbox.h>
#include <qlayout.h>
#include <qtooltip.h>
#include <qwhatsthis.h>
#include <qtextcodec.h>

#include <klocale.h>
#include <kiconloader.h>
#include <kfiledialog.h>

class QVBoxLayout;
class QHBoxLayout;
class QGridLayout;
class QCheckBox;
class QComboBox;
class QGroupBox;
class QLabel;
class QLineEdit;
class QPushButton;
class QSpinBox;

class ClickDlg : public QDialog
{
    Q_OBJECT

public:
    ClickDlg( QWidget* parent = 0, const char* name = 0, bool modal = FALSE, WFlags fl = 0 );
    ~ClickDlg();

    QPushButton* pushButton3;
    QGroupBox* groupBox1;
    QSpinBox* X;
    QSpinBox* Y;
    QSpinBox* W;
    QSpinBox* H;
    QLabel* XLabel;
    QLabel* YLabel;
    QLabel* UrlLabel;
    QLabel* WidthLabel;
    QLabel* HeightLabel;
    QLineEdit* URL;
    QLineEdit* Tooltip;
    QLabel* TipLabel;
    // Sensor Group
    QGroupBox* SensorBox;
    QLineEdit* Program;
    QLineEdit* Format;
    QLineEdit* Line;
    QLineEdit* OnClick;
    QLineEdit* Codec;
    QCheckBox* RDF;
    QCheckBox* useSens;
    QComboBox* SensorCombo;
    QLabel* OnclickLabel;
    QLabel* ProgramLabel;
    QLabel* LineLabel;
    QLabel* FormatLabel;
    QLabel* SensorLabel;
    QLabel* CodecLabel;
    // Global
    QCheckBox* insCur;
    QPushButton* pushButton1;
    QPushButton* pushButton2;

public slots:

protected:

protected slots:
    virtual void languageChange();
    virtual void selURL();
    virtual void ChooseProgram();
    virtual void UseSensor( bool );

};

#endif // ClickDlg_H
