#include "icone.h"

/*
 *  Constructs a Image as a child of 'parent', with the
 *  name 'name' and widget flags set to 'f'.
 *
 *  The dialog will by default be modeless, unless you set 'modal' to
 *  TRUE to construct a modal dialog.
 */
IconDlg::IconDlg( QWidget* parent, const char* name, bool modal, WFlags fl )
    : QDialog( parent, name, modal, fl )

{
    if ( !name )
	setName( "Icone" );
    setSizePolicy( QSizePolicy( (QSizePolicy::SizeType)0, (QSizePolicy::SizeType)0, 0, 0, sizePolicy().hasHeightForWidth() ) );
    setMinimumSize( QSize( 600, 380 ) );
    setMaximumSize( QSize( 600, 380 ) );

    i = new KIconLoader;

    groupBox1 = new QGroupBox( this, "groupBox1" );
    groupBox1->setGeometry( QRect( 20, 0, 561, 150 ) );
    groupBox1->setFrameShape( QGroupBox::GroupBoxPanel );
    groupBox1->setFrameShadow( QGroupBox::Sunken );

    X = new QSpinBox( groupBox1, "X" );
    X->setGeometry( QRect( 470, 15, 70, 21 ) );
    X->setMaxValue( 2048 );

    XLabel = new QLabel( groupBox1, "XLabel" );
    XLabel->setGeometry( QRect( 400, 15, 60, 21 ) );
    XLabel->setAlignment( int( QLabel::AlignVCenter | QLabel::AlignRight ) );

    Y = new QSpinBox( groupBox1, "Y" );
    Y->setGeometry( QRect( 470, 45, 70, 21 ) );
    Y->setMaxValue( 1200 );

    YLabel = new QLabel( groupBox1, "YLabel" );
    YLabel->setGeometry( QRect( 400, 45, 60, 21 ) );
    YLabel->setAlignment( int( QLabel::AlignVCenter | QLabel::AlignRight ) );

    S = new QSpinBox( groupBox1, "S" );
    S->setGeometry( QRect( 470, 75, 70, 21 ) );
    S->setMaxValue( 2048 );
    S->setValue(48);

    SizeLabel = new QLabel( groupBox1, "SizeLabel" );
    SizeLabel->setGeometry( QRect( 400, 75, 60, 21 ) );
    SizeLabel->setAlignment( int( QLabel::AlignVCenter | QLabel::AlignRight ) );

    Roll = new QSpinBox( groupBox1, "Roll" );
    Roll->setGeometry( QRect( 470, 105, 70, 21 ) );
    Roll->setMaxValue( 1200 );

    RollLabel = new QLabel( groupBox1, "RollLabel" );
    RollLabel->setGeometry( QRect( 300, 105, 160, 21 ) );
    RollLabel->setAlignment( int( QLabel::AlignVCenter | QLabel::AlignRight ) );

    icolab = new QLabel( groupBox1, "icoLab" );
    icolab->setGeometry( QRect( 10, 20, 200, 48 ) );
    icolab->setAlignment( int( QLabel::AlignVCenter | QLabel::AlignCenter ) );

    pushButton3 = new QPushButton( groupBox1, "pushButton3" );
    pushButton3->setGeometry( QRect( 220, 35, 100, 31 ) );
    pushButton3->setIconSet( SmallIconSet( "fileopen" ));

    centerCheck = new QCheckBox( groupBox1, "centerCheck" );
    centerCheck->setGeometry( QRect( 20, 75, 120, 20 ) );

    Tooltip = new QLineEdit( groupBox1, "Tooltip" );
    Tooltip->setGeometry( QRect( 20, 120, 300, 20 ) );

    TipLabel = new QLabel( groupBox1, "TipLabel" );
    TipLabel->setGeometry( QRect( 20, 105, 108, 20 ) );
    TipLabel->setAlignment( int( QLabel::AlignVCenter | QLabel::AlignLeft ) );

    SensorBox = new QGroupBox( this, "SensorBox" );
    SensorBox->setGeometry( QRect( 20, 155, 561, 150 ) );

    useSens = new QCheckBox( SensorBox, "useSens" );
    useSens->setGeometry( QRect( 20, 20, 160, 21 ) );

    Program = new QLineEdit( SensorBox, "Program" );
    Program->setEnabled( FALSE );
    Program->setGeometry( QRect( 390, 50, 160, 21 ) );
    Program->setReadOnly( FALSE );

    ProgramLabel = new QLabel( SensorBox, "ProgramLabel" );
    ProgramLabel->setEnabled( FALSE );
    ProgramLabel->setGeometry( QRect( 270, 50, 110, 21 ) );
    ProgramLabel->setAlignment( int( QLabel::AlignVCenter | QLabel::AlignRight ) );

    SensorCombo = new QComboBox( FALSE, SensorBox, "SensorCombo" );
    SensorCombo->setEnabled( FALSE );
    SensorCombo->setGeometry( QRect( 290, 20, 171, 21 ) );

    Codec = new QLineEdit( SensorBox, "Codec" );
    Codec->setEnabled( FALSE );
    Codec->setGeometry( QRect( 110, 90, 160, 21 ) );

    Format = new QLineEdit( SensorBox, "Format" );
    Format->setEnabled( FALSE );
    Format->setGeometry( QRect( 110, 50, 160, 21 ) );

    FormatLabel = new QLabel( SensorBox, "FormatLabel" );
    FormatLabel->setEnabled( FALSE );
    FormatLabel->setGeometry( QRect( 10, 90, 90, 21 ) );
    FormatLabel->setAlignment( int( QLabel::AlignVCenter | QLabel::AlignRight ) );

    Line = new QLineEdit( SensorBox, "Line" );
    Line->setEnabled( FALSE );
    Line->setGeometry( QRect( 390, 90, 160, 21 ) );

    CodecLabel = new QLabel( SensorBox, "CodecLabel" );
    CodecLabel->setEnabled( FALSE );
    CodecLabel->setGeometry( QRect( 10, 90, 90, 21 ) );
    CodecLabel->setAlignment( int( QLabel::AlignVCenter | QLabel::AlignRight ) );

    RDF = new QCheckBox( SensorBox, "RDF" );
    RDF->setGeometry( QRect( 20, 120, 200, 21 ) );
    RDF->setEnabled( FALSE );

    LineLabel = new QLabel( SensorBox, "LineLabel" );
    LineLabel->setEnabled( FALSE );
    LineLabel->setGeometry( QRect( 290, 90, 90, 21 ) );
    LineLabel->setAlignment( int( QLabel::AlignVCenter | QLabel::AlignRight ) );

    SensorLabel = new QLabel( SensorBox, "SensorLabel" );
    SensorLabel->setEnabled( FALSE );
    SensorLabel->setGeometry( QRect( 10, 50, 90, 21 ) );
    SensorLabel->setAlignment( int( QLabel::AlignVCenter | QLabel::AlignRight ) );

    insCur = new QCheckBox( this, "insCur" );
    insCur->setGeometry( QRect( 20, 310, 300, 20 ) );

    pushButton1 = new QPushButton( this, "pushButton1" );
    pushButton1->setGeometry( QRect( 190, 335, 81, 31 ) );
    pushButton1->setIconSet( SmallIconSet( "ok" ));
    pushButton1->setDefault(true);

    pushButton2 = new QPushButton( this, "pushButton2" );
    pushButton2->setGeometry( QRect( 340, 335, 81, 31 ) );
    pushButton2->setIconSet( SmallIconSet( "cancel" ));

    languageChange();

    // signals and slots connections
    connect( pushButton1, SIGNAL( clicked() ), this, SLOT( accept() ) );
    connect( pushButton2, SIGNAL( clicked() ), this, SLOT( close() ) );
    connect( pushButton3, SIGNAL( clicked() ), this, SLOT( selIcon() ) );
    connect( SensorCombo, SIGNAL( activated(const QString&) ), this, SLOT( ChooseProgram() ) );
    connect( useSens, SIGNAL( toggled(bool) ), this, SLOT( UseSensor(bool) ) );
}

/*
 *  Destroys the object and frees any allocated resources
 */
IconDlg::~IconDlg()
{
    // no need to delete child widgets, Qt does it all for us
}

/*
 *  Sets the strings of the subwidgets using the current
 *  language.
 */
void IconDlg::languageChange(){
    setCaption( tr2i18n( "Add Icon Meter" ) );
    groupBox1->setTitle( tr2i18n( "Icon Parameters" ) );
    Y->setPrefix( QString::null );
    Y->setSuffix( tr2i18n( "px" ) );
    YLabel->setText( tr2i18n( "Y axis:" ) );
    X->setPrefix( QString::null );
    X->setSuffix( tr2i18n( "px" ) );
    XLabel->setText( tr2i18n( "X axis:" ) );
    SizeLabel->setText( tr2i18n( "Size:" ) );
    RollLabel->setText( tr2i18n( "Roll-Over size:" ) );
    icolab->setText( tr2i18n( "Click\nbrowse button" ) );
    TipLabel->setText( tr2i18n( "Tooltip:" ) );
    TipLabel->adjustSize();
    pushButton3->setText( tr2i18n( "Browse" ) );
    centerCheck->setText( tr2i18n( "Center Icon" ) );
    QToolTip::add( centerCheck, tr2i18n( "If checked, the icon will be centered in a box of width*height.<br>If width and height are null, the image will be centered in the screen." ) );
    SensorBox->setTitle( tr2i18n( "Sensor" ) );
    useSens->setText( tr2i18n( "Use sensor" ) );
    SensorCombo->clear();
    SensorCombo->insertItem( tr2i18n( "CPU" ) );
    SensorCombo->insertItem( tr2i18n( "Memory" ) );
    SensorCombo->insertItem( tr2i18n( "Disk" ) );
    SensorCombo->insertItem( tr2i18n( "Network" ) );
    SensorCombo->insertItem( tr2i18n( "Time" ) );
    SensorCombo->insertItem( tr2i18n( "Uptime" ) );
    SensorCombo->insertItem( tr2i18n( "Sensor" ) );
    SensorCombo->insertItem( tr2i18n( "Textfile" ) );
    SensorCombo->insertItem( tr2i18n( "Noatun" ) );
    SensorCombo->insertItem( tr2i18n( "XMMS" ) );
    SensorCombo->insertItem( tr2i18n( "Program" ) );
    FormatLabel->setText( tr2i18n( "Format:" ) );
    ProgramLabel->setText( tr2i18n( "Program:" ) );
    LineLabel->setText( tr2i18n( "Line:" ) );
    SensorLabel->setText( tr2i18n( "Sensor:" ) );
    CodecLabel->setText( tr2i18n( "Encoding:" ) );
    RDF->setText( tr2i18n( "RDF file" ) );
    pushButton1->setText( tr2i18n( "Ok" ) );
    pushButton2->setText( tr2i18n( "Cancel" ) );
    insCur->setText( tr2i18n( "Insert at cursor position" ) );
}

void IconDlg::UseSensor( bool v ){
  SensorLabel->setEnabled(v);
  SensorCombo->setEnabled(v);
  Format->setEnabled(v);
  FormatLabel->setEnabled(v);
  LineLabel->setEnabled(v);
  Line->setEnabled(v);
  ProgramLabel->setEnabled(v);
  Program->setEnabled(v);
  CodecLabel->setEnabled(v);
  Codec->setEnabled(v);
  RDF->setEnabled(v);
  //Value->setEnabled(!v);
  pushButton3->setEnabled(!v);
  //ValueLabel->setEnabled(!v);
  if(v){
    ChooseProgram();
  }
}

void IconDlg::ChooseProgram(){
  if(SensorCombo->currentItem() == 0){
    ProgramLabel->setEnabled(false);
    Program->setEnabled(false);
    CodecLabel->setEnabled(false);
    Codec->setEnabled(false);
    FormatLabel->setEnabled(true);
    Format->setEnabled(true);
    Format->setText("%load");
    QToolTip::add( Format, tr2i18n( "%user<br>%system<br>%nice<br>%idle<br>%load (=%v)" ) );
    LineLabel->setEnabled(true);
    LineLabel->setText( tr2i18n( "CPU:" ) );
    Line->setEnabled(true);
    Line->setText("all");
    RDF->setEnabled(false);
  }
  else if(SensorCombo->currentItem() == 1){
    ProgramLabel->setEnabled(false);
    Program->setEnabled(false);
    CodecLabel->setEnabled(false);
    Codec->setEnabled(false);
    FormatLabel->setEnabled(true);
    Format->setEnabled(true);
    Format->setText("%fm");
    QToolTip::add( Format, tr2i18n( "%fm<br>%fmb<br>%um<br>%umb<br>%tm<br>%fs<br>%us<br>%ts" ) );
    LineLabel->setEnabled(false);
    Line->setEnabled(false);
    RDF->setEnabled(false);
  }
  else if(SensorCombo->currentItem() == 2){
    ProgramLabel->setEnabled(true);
    ProgramLabel->setText( tr2i18n( "MountPoint:" ) );
    Program->setEnabled(true);
    Program->setText("/");
    CodecLabel->setEnabled(false);
    Codec->setEnabled(false);
    FormatLabel->setEnabled(true);
    Format->setEnabled(true);
    Format->setText("%f");
    QToolTip::add( Format, tr2i18n( "%f<br>%fp<br>%u<br>%up<br>%t" ) );
    LineLabel->setEnabled(false);
    Line->setEnabled(false);
    RDF->setEnabled(false);
  }
  else if(SensorCombo->currentItem() == 3){
    ProgramLabel->setEnabled(true);
    ProgramLabel->setText( tr2i18n( "Device:" ) );
    Program->setEnabled(true);
    Program->setText("eth0");
    CodecLabel->setEnabled(false);
    Codec->setEnabled(false);
    FormatLabel->setEnabled(true);
    Format->setEnabled(true);
    Format->setText("%in");
    QToolTip::add( Format, tr2i18n( "%in<br>%out" ) );
    LineLabel->setEnabled(true);
    LineLabel->setText( tr2i18n( "Decimals:" ) );
    Line->setEnabled(true);
    Line->setText("0");
    RDF->setEnabled(false);
  }
  else if(SensorCombo->currentItem() == 4){
    ProgramLabel->setEnabled(false);
    Program->setEnabled(false);
    CodecLabel->setEnabled(false);
    Codec->setEnabled(false);
    FormatLabel->setEnabled(true);
    Format->setEnabled(true);
    Format->setText("dd.MM.yyyy");
    QToolTip::add( Format, tr2i18n( "d<br>dd<br>ddd<br>dddd<br>M<br>MM<br>MMM<br>MMMM<br>YY<br>YYYY<br>h<br>hh<br>m<br>mm<br>s<br>ss<br>z<br>zzz<br>AP<br>ap" ) );
    LineLabel->setEnabled(false);
    Line->setEnabled(false);
    RDF->setEnabled(false);
  }
  else if(SensorCombo->currentItem() == 5){
    ProgramLabel->setEnabled(false);
    Program->setEnabled(false);
    CodecLabel->setEnabled(false);
    Codec->setEnabled(false);
    FormatLabel->setEnabled(true);
    Format->setEnabled(true);
    Format->setText("%dd %h:%M");
    QToolTip::add( Format, tr2i18n( "%d<br>%h<br>%m<br>%s<br>%H<br>%M<br>%S" ) );
    LineLabel->setEnabled(false);
    Line->setEnabled(false);
    RDF->setEnabled(false);
  }
  else if(SensorCombo->currentItem() == 6){
    ProgramLabel->setEnabled(true);
    ProgramLabel->setText( tr2i18n( "Type:" ) );
    Program->setEnabled(true);
    Program->setText("temp2");
    CodecLabel->setEnabled(false);
    Codec->setEnabled(false);
    FormatLabel->setEnabled(true);
    Format->setEnabled(true);
    Format->setText("%v");
    QToolTip::add( Format, tr2i18n( "%v" ) );
    LineLabel->setEnabled(false);
    Line->setEnabled(false);
    RDF->setEnabled(false);
  }
  else if(SensorCombo->currentItem() == 7){
    ProgramLabel->setEnabled(true);
    ProgramLabel->setText( tr2i18n( "Path:" ) );
    Program->setEnabled(true);
    Program->setText("");
    CodecLabel->setEnabled(true);
    Codec->setEnabled(true);
    Codec->setText((QTextCodec::codecForLocale())->name());
    FormatLabel->setEnabled(true);
    Format->setEnabled(true);
    Format->setText("%v");
    QToolTip::add( Format, tr2i18n( "%v" ) );
    LineLabel->setEnabled(true);
    LineLabel->setText( tr2i18n( "Line:" ) );
    Line->setEnabled(true);
    Line->setText("");
    RDF->setEnabled(true);
  }
  else if(SensorCombo->currentItem() == 8){
    ProgramLabel->setEnabled(false);
    Program->setEnabled(false);
    CodecLabel->setEnabled(false);
    Codec->setEnabled(false);
    FormatLabel->setEnabled(true);
    Format->setEnabled(true);
    Format->setText("%id");
    QToolTip::add( Format, tr2i18n( "%id<br>%title<br>%time<br>%remain<br>%length<br>%full" ) );
    LineLabel->setEnabled(false);
    Line->setEnabled(false);
    RDF->setEnabled(false);
  }
  else if(SensorCombo->currentItem() == 9){
    ProgramLabel->setEnabled(false);
    Program->setEnabled(false);
    CodecLabel->setEnabled(true);
    Codec->setEnabled(true);
    Codec->setText((QTextCodec::codecForLocale())->name());
    FormatLabel->setEnabled(true);
    Format->setEnabled(true);
    Format->setText("%title");
    QToolTip::add( Format, tr2i18n( "<b>Outputs</b><br>%title<br>%time<br>%remain<br>%length<br>%full<br>%stitle<br>%artist<br>%album<br>%track<br>%cover<br>%rcover<br>%viewer<br>%rate<br>%freq<br>%channel<br>%monoster<br>%runquit<br>%vol<br>%ms" ) );
    LineLabel->setEnabled(false);
    Line->setEnabled(false);
    RDF->setEnabled(false);
  }
  else if(SensorCombo->currentItem() == 10){
    ProgramLabel->setEnabled(true);
    ProgramLabel->setText( tr2i18n( "Program:" ) );
    Program->setEnabled(true);
    CodecLabel->setEnabled(true);
    Codec->setEnabled(true);
    Codec->setText((QTextCodec::codecForLocale())->name());
    FormatLabel->setEnabled(true);
    Format->setEnabled(true);
    Format->setText("%v");
    QToolTip::add( Format, tr2i18n( "%v" ) );
    LineLabel->setEnabled(true);
    LineLabel->setText( tr2i18n( "Line:" ) );
    Line->setEnabled(true);
    Line->setText("");
    RDF->setEnabled(false);
  }
}

void IconDlg::selIcon(){
    KIconDialog* ico = new KIconDialog(this);
    icon = ico->getIcon();
    if( icon != ""){
      icolab->setPixmap( i->loadIcon( icon, KIcon::Group(-1), 48 ) );
    }
}

#include "icone.moc"

