#ifndef ICONE_H
#define ICONE_H

#include <qvariant.h>
#include <qdialog.h>
#include <qcheckbox.h>
#include <qcombobox.h>
#include <qgroupbox.h>
#include <qlabel.h>
#include <qlineedit.h>
#include <qpushbutton.h>
#include <qspinbox.h>
#include <qlayout.h>
#include <qtooltip.h>
#include <qwhatsthis.h>
#include <qtextcodec.h>

#include <klocale.h>
#include <kicondialog.h>
#include <ksimpleconfig.h>
#include <kstandarddirs.h>
#include <kiconloader.h>
#include <kicontheme.h>

class QVBoxLayout;
class QHBoxLayout;
class QGridLayout;
class QCheckBox;
class QComboBox;
class QGroupBox;
class QLabel;
class QLineEdit;
class QPushButton;
class QSpinBox;

class IconDlg : public QDialog
{
    Q_OBJECT

public:
    IconDlg( QWidget* parent = 0, const char* name = 0, bool modal = FALSE, WFlags fl = 0 );
    ~IconDlg();

    KIconLoader* i;
    QGroupBox* groupBox1;
    QSpinBox* X;
    QLabel* XLabel;
    QSpinBox* Y;
    QLabel* YLabel;
    QSpinBox* S;
    QLabel* SizeLabel;
    QSpinBox* Roll;
    QLabel* RollLabel;
    //QLabel* ValueLabel;
    //QLineEdit* Value;
    QString icon;
    QPushButton* pushButton3;
    QCheckBox* centerCheck;
    QLineEdit* Tooltip;
    QLabel* TipLabel;
    // Sensor Group
    QCheckBox* useSens;
    QGroupBox* SensorBox;
    QLabel* ProgramLabel;
    QLabel* LineLabel;
    QLabel* FormatLabel;
    QLabel* SensorLabel;
    QLabel* CodecLabel;
    QLabel* icolab;
    QComboBox* SensorCombo;
    QLineEdit* Program;
    QLineEdit* Format;
    QLineEdit* Line;
    QLineEdit* Codec;
    QCheckBox* RDF;
    // Global
    QCheckBox* insCur;
    QPushButton* pushButton1;
    QPushButton* pushButton2;

public slots:

protected:

protected slots:
    virtual void languageChange();
    virtual void ChooseProgram();
    virtual void selIcon();
    virtual void UseSensor( bool );

};

#endif // ICONE_H
