/***************************************************************************
 *   Copyright (C) 2003 by Bosselut Cyril                                   *
 *   bosselut@b1project.com                                                      *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/
#include "child.h"


Child::Child( int x, int y, int w, int h )
        : Meter( x, y, w, h ){
    theme = "";
    rect = QRect( x, y, w, h );
    myChild = 0;
    parent = 0;
}

Child::~Child(){
}


void Child::enter( QMouseEvent * ){
  if( theme != "" && (event == "over" || event == "ofocus") ){
    if(!myChild){
      myChild = new karamba(parent, theme, true);
      if(event == "ofocus"){
        connect( myChild,SIGNAL(ActiveWin(bool)), this,SLOT(hide(bool)) );
      }
      if(parent){
        myChild->setBackgroundMode(myKaramba->backgroundMode());
        if(myChild->backgroundMode() == PaletteBackground){
          myChild->setPaletteBackgroundColor(myKaramba->paletteBackgroundColor());
        }
      }
      myKaramba->KarChildList->append( myChild );
    }
    if(myChild->isHidden()){
      myChild->show();
      myChild->updateSensors();
    }
  }
}

void Child::leave( QMouseEvent * ){
  if(event == "over"){
    if( myChild ){
      if(myChild->isShown()){
        myChild->hide();
        myKaramba->setActiveWindow();
      }
    }
  }
}

void Child::hide(bool b){
  if( myChild && !b){
    if(myChild->isShown()){
      myChild->hide();
      myKaramba->setActiveWindow();
    }
  }
}

void Child::click( QMouseEvent *e ){
  if( rect.contains( e->x(), e->y() ) && (event == "click" || event == "cfocus") ){
    if( theme != "" ){
      if(!myChild){
        myChild = new karamba(parent, theme, true);
        if(event == "cfocus"){
          connect( myChild,SIGNAL(ActiveWin(bool)), this,SLOT(hide(bool)) );
        }
        if(parent){
          myChild->setBackgroundMode(myKaramba->backgroundMode());
          if(myChild->backgroundMode() == PaletteBackground){
            myChild->setPaletteBackgroundColor(myKaramba->paletteBackgroundColor());
          }
        }
        myKaramba->KarChildList->append( myChild );
        myChild->show();
      }
      else{
        if(myChild->isHidden()){
          myChild->show();
          myChild->updateSensors();
       }
        else if(myChild->isShown()){
          myChild->hide();
          myKaramba->setActiveWindow();
        }
      }
    }
  }
}

void Child::setEvent( QString e ){
    event = e;
}


QRect Child::getRectangle(){
    return rect;
}

void Child::mUpdate( QPainter *p ){

    p->drawRect( x, y, width, height );

}

void Child::setValue( int v){

    setValue( QString::number( v ) );

}

void Child::setValue( QString v ){
    theme = v;
}

void Child::setEmbed( bool b ){
  if(b){
    parent = myKaramba;
  }
  else{
    parent = 0;
  }
}

void Child::setTooltip(QString txt){
	QRect rect(x,y,width,height);
	QToolTip::add(myKaramba, rect, txt);
}

void Child::setKaramba(karamba* k){
	myKaramba = k;
}



