#include "karambaconf.h"

/*
 *  Constructs a KarambaConf as a child of Karamba with the
 *  name 'KarambaConf' .
 *
 */
KarambaConf::KarambaConf( QWidget* parent, const char* name, bool modal, WFlags fl )
    : QDialog( parent, name, modal, fl )
{
    loadConfig();
    if ( !name ){
      setName( "Karamba_conf" );
    }
    setMinimumSize( QSize( 600, 360 ) );
    setMaximumSize( QSize( 600, 360 ) );
    setSizeGripEnabled( TRUE );

    QWidget* privateLayoutWidget = new QWidget( this, "Layout1" );
    privateLayoutWidget->setGeometry( QRect( 11, 326, 575, 27 ) );
    Layout1 = new QHBoxLayout( privateLayoutWidget, 0, 6, "Layout1"); 

    buttonHelp = new QPushButton( privateLayoutWidget, "buttonHelp" );
    buttonHelp->setAutoDefault( TRUE );
    Layout1->addWidget( buttonHelp );
    QSpacerItem* spacer = new QSpacerItem( 20, 20, QSizePolicy::Expanding, QSizePolicy::Minimum );
    Layout1->addItem( spacer );

    buttonOk = new QPushButton( privateLayoutWidget, "buttonOk" );
    buttonOk->setAutoDefault( TRUE );
    buttonOk->setDefault( TRUE );
    Layout1->addWidget( buttonOk );

    buttonCancel = new QPushButton( privateLayoutWidget, "buttonCancel" );
    buttonCancel->setAutoDefault( TRUE );
    Layout1->addWidget( buttonCancel );

    QWidget* privateLayoutWidget_2 = new QWidget( this, "layout5" );
    privateLayoutWidget_2->setGeometry( QRect( 5, 0, 590, 320 ) );
    layout5 = new QHBoxLayout( privateLayoutWidget_2, 0, 0, "layout5");

    tabWidget = new QTabWidget( privateLayoutWidget_2, "tabWidget" );
    tabWidget->setEnabled( TRUE );
    tabWidget->setMinimumSize( QSize( 590, 320 ) );
    tabWidget->setMaximumSize( QSize( 590, 320 ) );
    tabWidget->setAutoMask( TRUE );

    Widget2 = new QWidget( tabWidget, "Widget2" );
    QWidget* privateLayoutWidget_3 = new QWidget( Widget2, "layout3" );
    privateLayoutWidget_3->setGeometry( QRect( 10, 10, 570, 280 ) );
    layout3 = new QVBoxLayout( privateLayoutWidget_3, 11, 6, "layout3");

    dFolderGroup = new QGroupBox( privateLayoutWidget_3, "dFolderGroup" );
    dFolderGroup->setGeometry( QRect( 0, 0, 570, 60 ) );

    dFolder = new QLineEdit( dFolderGroup, "dFolder" );
    dFolder->setGeometry( QRect( 20, 20, 250, 22 ) );
    dFolder->setText( Dir );

    browse_1 = new QPushButton( dFolderGroup, "browse_1" );
    browse_1->setGeometry( QRect( 300, 20, 100, 28 ) );
    layout3->addWidget( dFolderGroup );

    dThemeGroup = new QGroupBox( privateLayoutWidget_3, "dThemeGroup" );
    dThemeGroup->setGeometry( QRect( 10, 70, 570, 120 ) );

    dTheme = new QLineEdit( dThemeGroup, "dTheme" );
    dTheme->setGeometry( QRect( 20, 20, 250, 22 ) );
    dTheme->setText( Theme );

    browse_2 = new QPushButton( dThemeGroup, "browse_2" );
    browse_2->setGeometry( QRect( 300, 18, 100, 28 ) );
    themeLabel = new QLabel( dThemeGroup, "themeLabel" );
    themeLabel->setGeometry( QRect( 10, 50, 530, 40 ) );
    layout3->addWidget( dThemeGroup );

    dAppsGroup = new QGroupBox( privateLayoutWidget_3, "dAppsGroup" );
    dAppsGroup->setGeometry( QRect( 10, 200, 570, 50 ) );
    viewerLabel = new QLabel( dAppsGroup, "viewerLabel" );
    viewerLabel->setGeometry( QRect( 20, 24, 170, 22 ) );
    dViewer = new QLineEdit( dAppsGroup, "dViewer" );
    dViewer->setGeometry( QRect( 190, 20, 248, 22 ) );
    dViewer->setText( Viewer );
    browse_3 = new QPushButton( dAppsGroup, "browse_3" );
    browse_3->setGeometry( QRect( 440, 18, 100, 28 ) );
    layout3->addWidget( dAppsGroup );

    tabWidget->insertTab( Widget2, "" );

    Widget3 = new QWidget( tabWidget, "Widget3" );

    TagGroup = new QGroupBox( Widget3, "TagGroup" );
    TagGroup->setGeometry( QRect( 10, 10, 570, 60 ) );

    id3Check = new QCheckBox( TagGroup, "id3Check" );
    id3Check->setGeometry( QRect( 20, 18, 250, 21 ) );
    id3Check->setChecked(EnableID3);

    SaveId3Check = new QCheckBox( TagGroup, "SaveId3Check" );
    SaveId3Check->setGeometry( QRect( 260, 18, 250, 21 ) );
    SaveId3Check->setChecked(SaveID3);

    CoversGroup = new QGroupBox( Widget3, "CoversGroup" );
    CoversGroup->setGeometry( QRect( 10, 80, 570, 120 ) );

    CoverCheck = new QCheckBox( CoversGroup, "CoverCheck" );
    CoverCheck->setGeometry( QRect( 20, 18, 250, 21 ) );
    CoverCheck->setChecked(EnableCover);

    id3CoverCheck = new QCheckBox( CoversGroup, "id3CoverCheck" );
    id3CoverCheck->setGeometry( QRect( 260, 18, 250, 21 ) );
    id3CoverCheck->setChecked(EnableId3Cover);

    NetCoverCheck = new QCheckBox( CoversGroup, "NetCoverCheck" );
    NetCoverCheck->setGeometry( QRect( 260, 38, 300, 21 ) );
    NetCoverCheck->setChecked(NetCover);

    textLabel1 = new QLabel( CoversGroup, "textLabel1" );
    textLabel1->setGeometry( QRect( 20, 70, 250, 21 ) );

    cWidth = new QLineEdit( CoversGroup, "cWidth" );
    cWidth->setGeometry( QRect( 20, 90, 81, 21 ) );
    cWidth->setAlignment (Qt::AlignRight);
    cWidth->setText( QString::number( CoverWidth ) );

    textLabel2 = new QLabel( CoversGroup, "textLabel2" );
    textLabel2->setGeometry( QRect( 260, 70, 250, 21 ) );

    cHeight = new QLineEdit( CoversGroup, "cHeight" );
    cHeight->setGeometry( QRect( 260, 90, 81, 21 ) );
    cHeight->setAlignment (Qt::AlignRight);
    cHeight->setText( QString::number( CoverHeight ) );

    XmmsGroup = new QGroupBox( Widget3, "XmmsGroup" );
    XmmsGroup->setGeometry( QRect( 10, 210, 570, 60 ) );

    mainWinCheck = new QCheckBox( XmmsGroup, "mainWinCheck" );
    mainWinCheck->setGeometry( QRect( 20, 22, 250, 21 ) );
    mainWinCheck->setChecked(HideMainWin);

    tabWidget->insertTab( Widget3, "" );

    Widget4 = new QWidget( tabWidget, "Widget4" );
    QWidget* privateLayoutWidget_4 = new QWidget( Widget4, "layout4" );
    privateLayoutWidget_4->setGeometry( QRect( 10, 10, 570, 270 ) );

    Layout2 = new QGridLayout( privateLayoutWidget_4, 0, 0, KDialog::marginHint(), KDialog::spacingHint(), "Layout2");

    EmbedGroup = new QGroupBox( privateLayoutWidget_4, "EmbedGroup" );
    Layout6 = new QGridLayout( EmbedGroup, 0, 0, KDialog::marginHint(), KDialog::spacingHint(), "Layout6");
    Layout2->addWidget( EmbedGroup, 0, 0 );
    textLabel3 = new QLabel( EmbedGroup, "textLabel3" );
    textLabel3->setFixedSize( 250, 20 );
    Layout6->addWidget( textLabel3, 0, 0 );
    colorButton = new QPushButton( EmbedGroup, "colorButton" );
    colorButton->setText( bgc );
    colorButton->setPaletteBackgroundColor( bgColor );
    colorButton->setFixedSize( 100, 20 );
    Layout6->addWidget( colorButton, 0, 1 );
    Layout2->addWidget( EmbedGroup, 0, 0 );

    FadeGroup = new QGroupBox( privateLayoutWidget_4, "FadeGroup" );
    Layout4 = new QGridLayout( FadeGroup, 0, 0, KDialog::marginHint(), KDialog::spacingHint(), "Layout4");
    textLabel6 = new QLabel( FadeGroup, "textLabel6" );
    textLabel6->setFixedSize( 250, 20 );
    Layout4->addWidget( textLabel6, 0, 0 );
    fcolorButton = new QPushButton( FadeGroup, "fcolorButton" );
    fcolorButton->setText( fadec );
    fcolorButton->setPaletteBackgroundColor( fadeColor );
    fcolorButton->setFixedSize( 100, 20 );
    Layout4->addWidget( fcolorButton, 0, 1 );
    textLabel4 = new QLabel( FadeGroup, "textLabel4" );
    textLabel4->setFixedSize( 250, 20 );
    Layout4->addWidget( textLabel4, 1, 0 );
    fadeSpin = new QSpinBox(FadeGroup, "fadeSpin");
    fadeSpin->setMinValue(0);
    fadeSpin->setMaxValue(100);
    fadeSpin->setValue(int(fadeLevel*100));
    fadeSpin->setSuffix("%");
    fadeSpin->setFixedSize( 60, 20 );
    Layout4->addWidget( fadeSpin, 1, 1 );
    textLabel5 = new QLabel( FadeGroup, "textLabel5" );
    textLabel5->setFrameStyle( QFrame::GroupBoxPanel | QFrame::Sunken );
    textLabel5->setFixedSize( 64, 64 );
    Layout4->addMultiCellWidget( textLabel5, 0, 1, 2, 2 );
    slotTestFade(fadeSpin->value());
    Layout2->addWidget( FadeGroup, 1, 0 );

    tabWidget->insertTab( Widget4, "" );

    layout5->addWidget( tabWidget );
    languageChange();
    resize( QSize(600, 360).expandedTo(minimumSizeHint()) );

    toggleCover();
    // signals and slots connections
    connect( buttonOk, SIGNAL( clicked() ), this, SLOT( saveConfig() ) );
    connect( buttonCancel, SIGNAL( clicked() ), this, SLOT( reject() ) );
    connect( buttonHelp, SIGNAL( clicked() ), this, SLOT( help() ) );
    connect( browse_1, SIGNAL( clicked() ), this, SLOT( selThemeDir() ) );
    connect( browse_2, SIGNAL( clicked() ), this, SLOT( selDefaultTheme() ) );
    connect( browse_3, SIGNAL( clicked() ), this, SLOT( selDefaultViewer() ) );
    connect( colorButton, SIGNAL( clicked() ), this, SLOT( selColor() ) );
    connect( CoverCheck, SIGNAL( clicked() ), this, SLOT( toggleCover() ) );
    connect( id3Check, SIGNAL( clicked() ), this, SLOT( toggleCover() ) );
    connect( fadeSpin, SIGNAL( valueChanged( int ) ), this, SLOT( slotTestFade( int ) ) );
    connect( fcolorButton, SIGNAL( clicked() ), this, SLOT( selFadeColor() ) );
}

/*
 *  Destroys the object and frees any allocated resources
 */
KarambaConf::~KarambaConf()
{
    // no need to delete child widgets, Qt does it all for us
}

/*
 *  Sets the strings of the subwidgets using the current
 *  language.
 */
void KarambaConf::languageChange()
{
    setCaption( tr2i18n( "Karamba Configuration" ) );
    buttonHelp->setText( tr2i18n( "&Help" ) );
    buttonHelp->setAccel( QKeySequence( tr2i18n( "F1" ) ) );
    buttonOk->setText( tr2i18n( "&OK" ) );
    buttonOk->setAccel( QKeySequence( QString::null ) );
    buttonCancel->setText( tr2i18n( "&Cancel" ) );
    buttonCancel->setAccel( QKeySequence( QString::null ) );
    dFolderGroup->setTitle( tr2i18n( "Default themes folder" ) );
    browse_1->setText( tr2i18n( "Browse" ) );
    dThemeGroup->setTitle( tr2i18n( "Default theme" ) );
    browse_2->setText( tr2i18n( "Browse" ) );
    themeLabel->setText( tr2i18n( "Set your default theme.\nIt will be load at Karamba startup.\nYou can set it null if you want the open dialog." ) );
    themeLabel->adjustSize ();
    dAppsGroup->setTitle( tr2i18n( "Helper applications" ) );
    viewerLabel->setText( tr2i18n( "Default image viewer:" ) );
    viewerLabel->adjustSize ();
    browse_3->setText( tr2i18n( "Browse" ) );
    tabWidget->changeTab( Widget2, tr2i18n( "Karamba" ) );
    TagGroup->setTitle( tr2i18n( "OGG and MP3 Tags" ) );
    id3Check->setText( tr2i18n( "Enable Tags read" ) );
    SaveId3Check->setText( tr2i18n( "Enable Tags save" ) );
    CoversGroup->setTitle( tr2i18n( "Covers" ) );
    CoverCheck->setText( tr2i18n( "Enable cover display" ) );
    CoverCheck->adjustSize();
    id3CoverCheck->setText( tr2i18n( "Enable ID3 cover search" ) );
    id3CoverCheck->adjustSize();
    NetCoverCheck->setText( tr2i18n( "Enable Internet cover search" ) );
    NetCoverCheck->adjustSize();
    textLabel1->setText( tr2i18n( "Max cover width" ) );
    textLabel1->adjustSize();
    textLabel2->setText( tr2i18n( "Max cover height" ) );
    textLabel2->adjustSize();
    XmmsGroup->setTitle( tr2i18n( "XMMS" ) );
    mainWinCheck->setText( tr2i18n( "Always hide XMMS main window" ) );
    tabWidget->changeTab( Widget3, tr2i18n( "XMMS Sensor" ) );
    tabWidget->changeTab( Widget4, tr2i18n( "Colors options" ) );
    EmbedGroup->setTitle( tr2i18n( "Embed color" ) );
    textLabel3->setText( tr2i18n( "Default embended background color:" ) );
    textLabel3->adjustSize();
    FadeGroup->setTitle( tr2i18n( "Fading options" ) );
    textLabel4->setText( tr2i18n( "Fading Level:" ) );
    textLabel4->adjustSize();
    textLabel6->setText( tr2i18n( "Fading Color:" ) );
    textLabel6->adjustSize();
}

void KarambaConf::loadConfig(){
  KSimpleConfig conf("karambarc",true);
  conf.setGroup("karamba");
  Dir = conf.readEntry("ThemeDir", locateLocal("data", "karamba/themes/"));
  Theme =  conf.readEntry("DefaultTheme", "");
  Viewer =  conf.readEntry("ImgViewer", "");
  conf.setGroup("XMMS");
  EnableID3 = conf.readBoolEntry("EnableId3",false);
  SaveID3 = conf.readBoolEntry("SaveId3",false);
  EnableCover = conf.readBoolEntry("EnableCover",false);
  EnableId3Cover = conf.readBoolEntry("EnableId3Cover",false);
  NetCover = conf.readBoolEntry("EnableNetCover",false);
  CoverWidth = conf.readNumEntry("CoverWidth",64);
  CoverHeight = conf.readNumEntry("CoverHeight",64);
  HideMainWin = conf.readBoolEntry("HideMainWin",false);
  conf.setGroup("Embed");
  bgc = conf.readEntry("bgColor","0,0,0");
  bgColor = conf.readColorEntry("bgColor", 0);
  fadeColor = conf.readColorEntry("fadeColor", 0);
  fadec = conf.readEntry("fadeColor", "0,0,0");
  fadeLevel = conf.readDoubleNumEntry("fadeLevel",0.2);
}

void KarambaConf::saveConfig(){
  KSimpleConfig conf("karambarc",false);
  conf.setGroup("karamba");
  conf.writeEntry("ThemeDir", dFolder->text());
  conf.writeEntry("DefaultTheme", dTheme->text());
  conf.writeEntry("ImgViewer", dViewer->text());
  conf.setGroup("XMMS");
  if(id3Check->isChecked() == true){
    conf.writeEntry("EnableId3", "true");
    if(id3CoverCheck->isChecked() == true){
      conf.writeEntry("EnableId3Cover", "true");
    }
    else{
      conf.writeEntry("EnableId3Cover", "false");
    }
    if(SaveId3Check->isChecked() == true){
      conf.writeEntry("SaveId3", "true");
    }
    else{
      conf.writeEntry("SaveId3", "false");
    }
  }
  else{
    conf.writeEntry("EnableId3", "false");
    conf.writeEntry("EnableId3Cover", "false");
    conf.writeEntry("SaveId3", "false");
  }
  if(CoverCheck->isChecked() == true){
    conf.writeEntry("EnableCover", "true");
    if(NetCoverCheck->isChecked() == true){
      conf.writeEntry("EnableNetCover", "true");
    }
    else{
      conf.writeEntry("EnableNetCover", "false");
    }
  }
  else{
    conf.writeEntry("EnableCover", "false");
    conf.writeEntry("EnableNetCover", "false");
    conf.writeEntry("EnableId3Cover", "false");
  }
  conf.writeEntry("CoverWidth", cWidth->text());
  conf.writeEntry("CoverHeight", cHeight->text());
  if(mainWinCheck->isChecked() == true){
    conf.writeEntry("HideMainWin", "true");
  }
  else{
    conf.writeEntry("HideMainWin", "false");
  }
  conf.setGroup("Embed");
  conf.writeEntry("bgColor", bgColor);
  conf.writeEntry("fadeColor", fadeColor);
  conf.writeEntry("fadeLevel", double(fadeSpin->value())/100);
  conf.sync();
  accept();
}

void KarambaConf::selThemeDir(){
  KDirSelectDialog dirName;
  KURL ndir;
  ndir = dirName.selectDirectory(Dir, false, 0, "Select default folder");
  if( ndir.path() != ""){
    dFolder->setText( ndir.path() );
  }
}

void KarambaConf::selDefaultTheme(){
    QString fileName;
    fileName = KFileDialog::getOpenFileName(Dir, "*.theme", 0, "Open configurations");
    QUrl url(fileName); //make QUrl from QString
    fileName = (url.dirPath() == Dir)?url.fileName():fileName; //verify if the theme is in default dir
    if( fileName != ""){
      dTheme->setText( fileName );
      Theme = fileName;
    }
}

void KarambaConf::selDefaultViewer(){
    QString fileName;
    fileName = KFileDialog::getOpenFileName(Dir, "*", 0, "Choose image viewer");
    if( fileName != ""){
      dViewer->setText( fileName );
      Viewer = fileName;
    }
}

void KarambaConf::toggleCover(){
  bool c = CoverCheck->isChecked();
  bool i = id3Check->isChecked();
  cWidth->setEnabled ( c );
  cHeight->setEnabled ( c );
  id3CoverCheck->setEnabled ( c && i );
  NetCoverCheck->setEnabled ( c );
  SaveId3Check->setEnabled ( i );
}

void KarambaConf::selColor(){
  int result = KColorDialog::getColor( bgColor );
  if ( result == KColorDialog::Accepted ){
    colorButton->setPaletteBackgroundColor( bgColor );
    bgc = QString::number(bgColor.red()) + "," + QString::number(bgColor.green()) + "," + QString::number(bgColor.blue());
    colorButton->setText( bgc );
  }
}

void KarambaConf::help(){
  KRun::runCommand( "khelpcenter help:/karamba" );
}

void KarambaConf::slotTestFade( int f=0 ){
  KIconLoader* i = new KIconLoader;
  KPixmap ftest;
  KPixmap ico;
  double val;
  ftest.resize(64, 64);
  ftest.fill(paletteBackgroundColor());
  ico = i->loadIcon( "kmenu", KIcon::Group(2), 64 );
  bitBlt(&ftest,0,0,&ico,0,Qt::CopyROP);
  val = double(f)/100;
  ftest = KPixmapEffect::fade(ftest, val, fadeColor);
  textLabel5->setPixmap(ftest);
}

void KarambaConf::selFadeColor(){
  int result = KColorDialog::getColor( fadeColor );
  if ( result == KColorDialog::Accepted ){
    fcolorButton->setPaletteBackgroundColor( fadeColor );
    fadec = QString::number(fadeColor.red()) + "," + QString::number(fadeColor.green()) + "," + QString::number(fadeColor.blue());
    fcolorButton->setText( fadec );
    slotTestFade(fadeSpin->value()); 
  }
}

#include "karambaconf.moc"
