//
//
// C++ Interface: Tags
//
// Description: 
//
//
// Author: Bosselut Cyril <bosselut@b1project.com>, (C) 2003
//
// Copyright: See COPYING file that comes with this distribution
//
//
#ifndef TAGS_H
#define TAGS_H
#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <id3/tag.h>
#include <id3/misc_support.h>
#include <vorbis/vorbisfile.h>
#include <vorbis/codec.h>

#include <stdlib.h>
#include <stdio.h>

#include <qurl.h>
#include <qfile.h>
#include <qimage.h>
#include <qvariant.h>

#include <kstandarddirs.h>
#include <kio/netaccess.h>
#include <kio/jobclasses.h>
#include <kmimemagic.h>
#include <kfilemetainfo.h>
#include <klibloader.h>
#include <kdebug.h>

/**
* @author Bosselut Cyril <bosselut@b1project.com>
* @version 0.23
*/
class Tags
{
public:
    Tags( QString fn );

    ~Tags();

    void setInfos(QString tr, QString ar, QString ti, QString al);
    void ReadId3();
    void WriteId3();
    void ReadVorbis();
    void WriteVorbis();
     /**
    * get cover from id3 tag
    */
    bool id3cover(int w, int h);
    /**
    * get cover from Darktown
    */
    bool darkcover(QString dir);
    /**
    * get cover from file location
    */
    QString setCover(int w, int h, QString cover);
    /**
    * Return true if file is an mp3
    */
    bool isMP3();
    /**
    * Return true if file is an ogg
    */
    bool isOGG();
     /**
    * Temporary cover file
    */
    QString fp;
     /**
    * artist + title + album or xmms output title
    */
    QString title;
    /**
    * artist
    */
    QString artist;
    /**
    * album
    */
    QString album;
    /**
    * song title
    */
    QString stitle;
    /**
    * track number
    */
    QString track;
    /**
    * last position in playlist
    */
    int current;
    /**
    * music file
    */
    QString file;
    /**
    * bitrate in bps
    */
    int rate;
    /**
    * frequency in hz
    */
    double freq;
    /**
    * number of channel (1 = mono, 2 = stereo)
    */
    int channel;
    /**
    * pointer on id3 tag
    */
    ID3_Tag* myTag;
   /**
    * Case upper the first letter of each words
    */
    QString upFirst(QString str);

};

#endif
